package cn.estsh.i3plus.ext.mes.apiservice.controller.busi.bu3;

import cn.estsh.i3plus.ext.mes.api.busi.bu3.ISxEnergyCompositeRatePassAnalysisService;
import cn.estsh.i3plus.ext.mes.pojo.model.bu3.SxEnergyCompositeRateAnalysisModel;
import cn.estsh.i3plus.ext.mes.pojo.model.bu3.SxEnergyCompositeRatePassAnalysisModel;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtConstWords;
import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.impp.framework.base.controller.MesBaseController;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(CommonConstWords.BASE_URL_MES)
@Api(tags = "综合能率推移分析（制造能率）报表控制层")
public class SxEnergyCompositeRatePassAnalysisController extends MesBaseController {

    @Autowired
    private ISxEnergyCompositeRatePassAnalysisService energyCompositeRatePassAnalysisService;

    @PostMapping(value = "/sx/ext/energy-composite-rate-pass-analysis/query")
    @ApiOperation(value = "综合能率推移分析（制造能率）报表")
    public ResultBean queryEnergyCompositeRatePassAnalysis(@RequestBody SxEnergyCompositeRatePassAnalysisModel data) {
        try {
            ValidatorBean.beginValid(data)
                    .notNull(MesExtConstWords.FLAG, data.getFlag())
                    .notNull(MesExtConstWords.DIMENSION, data.getDimension())
                    .notNull(MesExtConstWords.WORK_TIME_START, data.getWorkTimeStart())
                    .notNull(MesExtConstWords.WORK_TIME_END, data.getWorkTimeEnd());
            data.setOrganizeCode(AuthUtil.getOrganize().getOrganizeCode());
            return ResultBean.success("查询成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode())
                    .setResultObject(energyCompositeRatePassAnalysisService.queryEnergyCompositeRatePassAnalysis(data));
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @PostMapping(value = "/sx/ext/energy-composite-rate-analysis/query")
    @ApiOperation(value = "综合能率分析报表")
    public ResultBean queryEnergyCompositeRateAnalysis(@RequestBody SxEnergyCompositeRateAnalysisModel data) {
        try {
            ValidatorBean.beginValid(data)
                    .notNull(MesExtConstWords.DIMENSION, data.getDimension())
                    .notNull(MesExtConstWords.WORK_TIME_START, data.getWorkTimeStart())
                    .notNull(MesExtConstWords.WORK_TIME_END, data.getWorkTimeEnd());
            data.setOrganizeCode(AuthUtil.getOrganize().getOrganizeCode());
            return ResultBean.success("查询成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode())
                    .setResultObject(energyCompositeRatePassAnalysisService.queryEnergyCompositeRateAnalysis(data));
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}
